import { __decorate, __awaiter } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule, ɵɵinject } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { SwPush } from '@angular/service-worker';
import { Observable } from 'rxjs';
import { take } from 'rxjs/operators';

let NotificationLibService = class NotificationLibService {
    constructor() { }
};
NotificationLibService.ɵprov = ɵɵdefineInjectable({ factory: function NotificationLibService_Factory() { return new NotificationLibService(); }, token: NotificationLibService, providedIn: "root" });
NotificationLibService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NotificationLibService);

let NotificationLibComponent = class NotificationLibComponent {
    constructor() { }
    ngOnInit() {
    }
};
NotificationLibComponent = __decorate([
    Component({
        selector: 'lib-notification-lib',
        template: `
    <p>
      notification-lib works!
    </p>
  `
    })
], NotificationLibComponent);

let NotificationLibModule = class NotificationLibModule {
};
NotificationLibModule = __decorate([
    NgModule({
        declarations: [NotificationLibComponent],
        imports: [],
        exports: [NotificationLibComponent]
    })
], NotificationLibModule);

class GlobalConfig {
    constructor() {
    }
    static setConfig(configObj) {
        this.config = configObj;
    }
    static getConfig() {
        if (this.config)
            return this.config;
        else
            return null;
    }
}
GlobalConfig.config = null;

let NotificationService = class NotificationService {
    constructor(swPush, httpClient) {
        this.swPush = swPush;
        this.httpClient = httpClient;
    }
    // public getPublicKey(): Observable<string> {
    //   return this.httpClient.get<string>(environment.notificationBaseUrl + "/publicKey");
    // }
    // Retrieve subscription info of the browser
    getSubscription() {
        return new Observable(observer => {
            this.swPush.subscription.pipe(take(1)).subscribe(pushSubscription => {
                if (pushSubscription) {
                    observer.next(pushSubscription);
                }
                else {
                    observer.next(pushSubscription);
                }
            });
        });
    }
    //Form subscription request
    formSubscriptionRequest(userId, organisation, subscription) {
        const subscriptionRequest = {
            "userId": userId,
            "organisation": organisation,
            "subscriptionInfo": subscription
        };
        return subscriptionRequest;
    }
    requestSubscription(userId, organisation) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                this.getSubscription().subscribe((response) => __awaiter(this, void 0, void 0, function* () {
                    if (response) {
                        // console.log(response);
                    }
                    else {
                        // Subscribe to the browser
                        const subscription = yield this.swPush.requestSubscription({
                            serverPublicKey: GlobalConfig.getConfig().notificationPublicKey
                        });
                        const request = this.formSubscriptionRequest(userId, organisation, subscription);
                        // Call api to store the subscription info
                        this.httpClient.post(GlobalConfig.getConfig().notificationBaseUrl + "/subscribe", request).subscribe(response => {
                            // console.log(response);
                        });
                    }
                }));
            }
            catch (err) {
                console.error('Could not subscribe due to:', err);
            }
        });
    }
    subscribeToNotification(userId, organisation) {
        // Validate browser notification permission to request subscription
        if (Notification.permission === 'default') {
            Notification.requestPermission().then(() => {
                this.requestSubscription(userId, organisation);
            }).catch(() => {
                // show permission denied error
            });
        }
        else if (Notification.permission === 'denied') {
            // show permission is denied, please allow it error
        }
        else {
            this.requestSubscription(userId, organisation);
        }
    }
    unsubscribeToNotification(userId, organisation) {
        this.getSubscription().subscribe(subscriptionInfo => {
            const request = this.formSubscriptionRequest(userId, organisation, subscriptionInfo);
            // Call api to remove the subscription info
            this.httpClient.post(GlobalConfig.getConfig().notificationBaseUrl + "/unsubscribe", request).subscribe(response => {
                // console.log(response);
            });
        });
        // Unsubscribe from the browser
        this.swPush.unsubscribe();
    }
    sendNotification(notificationRequest) {
        // Call api to send the notification
        this.httpClient.post(GlobalConfig.getConfig().notificationBaseUrl + "/send", notificationRequest).subscribe(response => {
            // console.log(response);
        });
    }
};
NotificationService.ctorParameters = () => [
    { type: SwPush },
    { type: HttpClient }
];
NotificationService.ɵprov = ɵɵdefineInjectable({ factory: function NotificationService_Factory() { return new NotificationService(ɵɵinject(SwPush), ɵɵinject(HttpClient)); }, token: NotificationService, providedIn: "root" });
NotificationService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NotificationService);

/*
 * Public API Surface of notification-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { GlobalConfig, NotificationLibComponent, NotificationLibModule, NotificationLibService, NotificationService };
//# sourceMappingURL=webpush-notification-lib.js.map
