import { __decorate, __awaiter, __generator } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Component, NgModule, ɵɵinject } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { SwPush } from '@angular/service-worker';
import { Observable } from 'rxjs';
import { take } from 'rxjs/operators';

var NotificationLibService = /** @class */ (function () {
    function NotificationLibService() {
    }
    NotificationLibService.ɵprov = ɵɵdefineInjectable({ factory: function NotificationLibService_Factory() { return new NotificationLibService(); }, token: NotificationLibService, providedIn: "root" });
    NotificationLibService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NotificationLibService);
    return NotificationLibService;
}());

var NotificationLibComponent = /** @class */ (function () {
    function NotificationLibComponent() {
    }
    NotificationLibComponent.prototype.ngOnInit = function () {
    };
    NotificationLibComponent = __decorate([
        Component({
            selector: 'lib-notification-lib',
            template: "\n    <p>\n      notification-lib works!\n    </p>\n  "
        })
    ], NotificationLibComponent);
    return NotificationLibComponent;
}());

var NotificationLibModule = /** @class */ (function () {
    function NotificationLibModule() {
    }
    NotificationLibModule = __decorate([
        NgModule({
            declarations: [NotificationLibComponent],
            imports: [],
            exports: [NotificationLibComponent]
        })
    ], NotificationLibModule);
    return NotificationLibModule;
}());

var GlobalConfig = /** @class */ (function () {
    function GlobalConfig() {
    }
    GlobalConfig.setConfig = function (configObj) {
        this.config = configObj;
    };
    GlobalConfig.getConfig = function () {
        if (this.config)
            return this.config;
        else
            return null;
    };
    GlobalConfig.config = null;
    return GlobalConfig;
}());

var NotificationService = /** @class */ (function () {
    function NotificationService(swPush, httpClient) {
        this.swPush = swPush;
        this.httpClient = httpClient;
    }
    // public getPublicKey(): Observable<string> {
    //   return this.httpClient.get<string>(environment.notificationBaseUrl + "/publicKey");
    // }
    // Retrieve subscription info of the browser
    NotificationService.prototype.getSubscription = function () {
        var _this = this;
        return new Observable(function (observer) {
            _this.swPush.subscription.pipe(take(1)).subscribe(function (pushSubscription) {
                if (pushSubscription) {
                    observer.next(pushSubscription);
                }
                else {
                    observer.next(pushSubscription);
                }
            });
        });
    };
    //Form subscription request
    NotificationService.prototype.formSubscriptionRequest = function (userId, organisation, subscription) {
        var subscriptionRequest = {
            "userId": userId,
            "organisation": organisation,
            "subscriptionInfo": subscription
        };
        return subscriptionRequest;
    };
    NotificationService.prototype.requestSubscription = function (userId, organisation) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    this.getSubscription().subscribe(function (response) { return __awaiter(_this, void 0, void 0, function () {
                        var subscription, request;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!response) return [3 /*break*/, 1];
                                    return [3 /*break*/, 3];
                                case 1: return [4 /*yield*/, this.swPush.requestSubscription({
                                        serverPublicKey: GlobalConfig.getConfig().notificationPublicKey
                                    })];
                                case 2:
                                    subscription = _a.sent();
                                    request = this.formSubscriptionRequest(userId, organisation, subscription);
                                    // Call api to store the subscription info
                                    this.httpClient.post(GlobalConfig.getConfig().notificationBaseUrl + "/subscribe", request).subscribe(function (response) {
                                        // console.log(response);
                                    });
                                    _a.label = 3;
                                case 3: return [2 /*return*/];
                            }
                        });
                    }); });
                }
                catch (err) {
                    console.error('Could not subscribe due to:', err);
                }
                return [2 /*return*/];
            });
        });
    };
    NotificationService.prototype.subscribeToNotification = function (userId, organisation) {
        var _this = this;
        // Validate browser notification permission to request subscription
        if (Notification.permission === 'default') {
            Notification.requestPermission().then(function () {
                _this.requestSubscription(userId, organisation);
            }).catch(function () {
                // show permission denied error
            });
        }
        else if (Notification.permission === 'denied') {
            // show permission is denied, please allow it error
        }
        else {
            this.requestSubscription(userId, organisation);
        }
    };
    NotificationService.prototype.unsubscribeToNotification = function (userId, organisation) {
        var _this = this;
        this.getSubscription().subscribe(function (subscriptionInfo) {
            var request = _this.formSubscriptionRequest(userId, organisation, subscriptionInfo);
            // Call api to remove the subscription info
            _this.httpClient.post(GlobalConfig.getConfig().notificationBaseUrl + "/unsubscribe", request).subscribe(function (response) {
                // console.log(response);
            });
        });
        // Unsubscribe from the browser
        this.swPush.unsubscribe();
    };
    NotificationService.prototype.sendNotification = function (notificationRequest) {
        // Call api to send the notification
        this.httpClient.post(GlobalConfig.getConfig().notificationBaseUrl + "/send", notificationRequest).subscribe(function (response) {
            // console.log(response);
        });
    };
    NotificationService.ctorParameters = function () { return [
        { type: SwPush },
        { type: HttpClient }
    ]; };
    NotificationService.ɵprov = ɵɵdefineInjectable({ factory: function NotificationService_Factory() { return new NotificationService(ɵɵinject(SwPush), ɵɵinject(HttpClient)); }, token: NotificationService, providedIn: "root" });
    NotificationService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NotificationService);
    return NotificationService;
}());

/*
 * Public API Surface of notification-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { GlobalConfig, NotificationLibComponent, NotificationLibModule, NotificationLibService, NotificationService };
//# sourceMappingURL=webpush-notification-lib.js.map
