import { HttpClient } from '@angular/common/http';
import { SwPush } from '@angular/service-worker';
import { Observable } from 'rxjs';
import { NotificationRequest } from '../objects/NotificationRequest';
export declare class NotificationService {
    private swPush;
    private httpClient;
    constructor(swPush: SwPush, httpClient: HttpClient);
    getSubscription(): Observable<unknown>;
    formSubscriptionRequest(userId: string, organisation: string, subscription: any): {
        userId: string;
        organisation: string;
        subscriptionInfo: any;
    };
    requestSubscription(userId: string, organisation: string): Promise<void>;
    subscribeToNotification(userId: string, organisation: string): void;
    unsubscribeToNotification(userId: string, organisation: string): void;
    sendNotification(notificationRequest: NotificationRequest): void;
}
